
// ING Specific Transaction Map Function

mappers.ing = function (rawTransaction) {
	// Gather amount information
	var absAmount = parseFloat(rawTransaction["Bedrag (EUR)"].replace(',','.'));
	var signAmount = rawTransaction["Af Bij"] == "Bij" ? 1 : -1;
	
	// Date
	var year = rawTransaction["Datum"].substr(0,4);
	var month = parseInt(rawTransaction["Datum"].substr(4,2)) - 1;
	var day = rawTransaction["Datum"].substr(6,2);
	
	// Accounts
	var myAccount = rawTransaction["Rekening"];
	var otherAccount = rawTransaction["Tegenrekening"];
	var otherName = rawTransaction["Naam / Omschrijving"];
	
	// Information
	var information = rawTransaction["Mededelingen"];
	
	// Return a new transaction object based on the data from the raw transaction
	var transactionObject = {
		amount: signAmount * absAmount,
		
		date: new Date(year, month, day),
		
		myAccount: myAccount,
		otherAccount: otherAccount,
		otherName: otherName,
		
		information: information,
	};
	return new Transaction(transactionObject);
};

