var longMonthNames = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ];
var monthNames = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];

var Transaction = function(transactionObject) {
	
	var hashFnv32a = function(str, asString, seed) {
		var i, l,
			hval = (seed === undefined) ? 0x811c9dc5 : seed;

		for (i = 0, l = str.length; i < l; i++) {
			hval ^= str.charCodeAt(i);
			hval += (hval << 1) + (hval << 4) + (hval << 7) + (hval << 8) + (hval << 24);
		}
		if( asString ){
			// Convert to 8 digit hex string
			return ("0000000" + (hval >>> 0).toString(16)).substr(-8);
		}
		return hval >>> 0;
	};
	
	// Calculate a hash based on the values in the transactionObject
	// Note that the hash doesn't have to be unique across all transactions
	// When two identical transaction have occurred they will have the same hash
	this.hash = _.values(transactionObject).reduce(function(hash, val, ind, arr) { return hashFnv32a((typeof val.toFixed === "function") ? val.toFixed(2) : val.toString(), ind === arr.length - 1, hash); });
	
	this.amount = transactionObject.amount;
	this.date = transactionObject.date;
	this.myAccount = transactionObject.myAccount;
	this.otherAccount = transactionObject.otherAccount;
	this.otherName = transactionObject.otherName;
	this.information = transactionObject.information;
	
	
};

Transaction.prototype.getKeyValue = function(key) {
	var format00 = function(val) {
		return ("00" + val).slice (-2)
	};
	switch (key) {
	case "year":
		return { 
			name: "y" + this.date.getFullYear(), 
			label: "Year " + this.date.getFullYear() 
		};
	case "month":
		return { 
			name: "y" + this.date.getFullYear() + "_m" + format00(this.date.getMonth() + 1), 
			label: monthNames[this.date.getMonth()] + " " + this.date.getFullYear() 
		};
	case "week":
		return { 
			name: "y" + this.date.getWeekYear() + "_w" + format00(this.date.getWeek()), 
			label: "Week " + this.date.getWeek() + " in " + this.date.getWeekYear() 
		};
	case "day":
		return { 
			name: "y" + this.date.getFullYear() + "_m" + format00(this.date.getMonth() + 1) + "_d" + format00(this.date.getDate()), 
			label: this.date.getDate() + " " + monthNames[this.date.getMonth()] + " " + this.date.getFullYear()
		};
	}
};